#include <QGuiApplication>
#include <QQmlApplicationEngine>

#include <QObject>
#include <QVector>

class ComponentEntityDatabase : public QObject
{
    Q_OBJECT

public:
    ComponentEntityDatabase() {}

    enum ComponentDataUpdatePolicy {
        DestructiveDataUpdate,
        NonDestructiveDataUpdate
    };
    Q_ENUM(ComponentDataUpdatePolicy)
};

class QmlComponentDataChanger : public QObject
{
    Q_OBJECT

public:
    explicit QmlComponentDataChanger(QObject *parent = 0) {}
    ~QmlComponentDataChanger() {}

    Q_INVOKABLE void writeComponentData(const QJSValue &value, ComponentEntityDatabase::ComponentDataUpdatePolicy componentDataUpdatePolicy) {}

private:
    ComponentEntityDatabase *mEntityDatabase;
};

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QGuiApplication app(argc, argv);

    qmlRegisterUncreatableType<ComponentEntityDatabase>(
        "App", 1, 0, "ComponentEntityDatabase", "ComponentEntityDatabase should not be created in QML");
    qmlRegisterType<QmlComponentDataChanger>("App", 1, 0, "ComponentDataChanger");

    ComponentEntityDatabase database;

    QQmlApplicationEngine engine;
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
    if (engine.rootObjects().isEmpty())
        return -1;

    engine.rootObjects().first()->setProperty("database", QVariant::fromValue(&database));

    return app.exec();
}

#include "main.moc"
